<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8"/>
	<meta type="Content-type" content="text/html;charset=UTF-8" />
	<title>最大连续子数组-分治法</title>
	<style type="text/css"></style>
</head>
<body>
	<script type="text/javascript">
		function maxAddSub(arr,from,to){
		   if(to==from){
		   		return arr=[from];
		   }
			var middle=Math.floor((from+to)/2);
			var m1=maxAddSub(arr,from,middle);
			var m2=maxAddSub(arr,middle+1,to);
			var left=arr[middle],now=arr[middle];
			for(var i=middle-1;i>=from;i--){
			   	now+=arr[i];
			   	left=Math.max(now,left);

			}
			var right=arr[middle+1];
			now=arr[middle+1];
			for(var i=middle+2;i<=to;i++){
			   	now+=arr[i];
			   	right=Math.max(now,right);
			}
			var m3=left+right;
			return Math.max(m1,m2,m3);
		};
		var arr=[5,1,2];
		//var arr=[1,-2,3,10,-4,7,2,-5];//[3,10,-4,7,2]
		console.log(maxAddSub(arr,0,arr.length-1));
	</script>
</body>
</html>